<template>
    <div>
        <div>
            <router-link
                tag="button"
                class="uk-button uk-button-default uk-align-right"
                :to="'CreationLecon'"
            >
                Ajouter
            </router-link>
            <h1 class="uk-margin-top">
                <a href="#modal-description" uk-toggle class="type">Leçons</a>
            </h1>
        </div>
        <div uk-grid class="uk-width-1-1 uk-margin-bottom">
            <div class="uk-width-1-2">
                <input
                    class="uk-input "
                    type="text"
                    placeholder="Recherche un titre"
                    v-on:input="mettreAJourRecherche($event.target.value)"
                />
            </div>
            <FiltreParNiveau
                class="uk-width-1-2 uk-margin-small-top"
                @setValeursNiveau="setValeursNiveau"
            />
        </div>
        <div>
            <Multiselect
                v-model="tagsUtilise"
                tag-placeholder="Ajouter ce tag"
                placeholder="Recherche un tag"
                selectLabel="Appuyez sur Entrée pour ajouter"
                deselectLabel="Appuyez sur Entrée pour supprimer"
                label="name"
                track-by="code"
                :options="tagsDisponibles"
                :multiple="true"
                @input="filtrerLecons"
                class="uk-margin-small-bottom"
            />
        </div>
        <div class="uk-flex uk-margin-bottom">
            <div>
                <button class="uk-button uk-button-default" type="button">
                    Filtrer leçons non données aux élèves
                    <span uk-icon="icon:  triangle-down"></span>
                </button>
                <div
                    uk-dropdown="mode: click; boundary: ! .uk-button-group; boundary-align: true;"
                >
                    <AffichageClassesEleves
                        v-if="classes.length > 0"
                        :classes="classes"
                        @action="enregistrerElevesSansLecon"
                    />
                </div>
            </div>

            <div class="uk-margin-small-left">
                <button class="uk-button uk-button-default" type="button">
                    Filtrer leçons déjà données aux élèves
                    <span uk-icon="icon:  triangle-down"></span>
                </button>
                <div
                    uk-dropdown="mode: click; boundary: ! .uk-button-group; boundary-align: true;"
                >
                    <AffichageClassesEleves
                        v-if="classes.length > 0"
                        :classes="classes"
                        @action="enregistrerElevesPossedantLecon"
                    />
                </div>
            </div>
            <div class="uk-margin-small-left">
                <ListeTypeExercice @action="changerTypeExercice" />
            </div>
        </div>
        <div class="uk-child-width-1-5@m uk-grid-small uk-grid-match" uk-grid>
            <router-link
                tag="div"
                v-for="lecon in leconAAfficher"
                :key="lecon.id"
                :to="{
                    name: 'VisualisationLecon',
                    params: { id: lecon.id }
                }"
            >
                <ElementListeLecon :lecon="lecon" />
            </router-link>
        </div>

        <div id="modal-description" class="uk-flex-top" uk-modal>
            <div class="uk-modal-dialog uk-modal-body uk-margin-auto-vertical">
                <button
                    class="uk-modal-close-default"
                    type="button"
                    uk-close
                ></button>
                <p>Salut à toi !</p>
                <p>
                    Si tu vois ceci, c'est que tu as décidé d'enseigner le Go,
                    que ce soit dans une école, dans le club de ta ville ou
                    encore sur internet.
                </p>
                <p>Et pour ça tout d'abord : Merci !</p>
                <p>Ensuite, quelques explications s'imposent :</p>
                <p>
                    Ici, tu vas pouvoir écrire des leçons qui seront disponibles
                    pour tous les autres professeurs qui utilisent Gollege.
                    L'objectif est de s'entraider pour que le Go soit plus
                    facile à partager, même pour des clubs qui débutent.
                </p>
                <p>
                    Envie de la cacher aux autres ? Je peux le comprendre et ai
                    prévu une case à cochée "privé" pour la rendre invisible aux
                    professeurs qui ne font pas parti de ton club. Mais sache
                    deux choses : cela m' attriste que tu ne souhaites pas
                    partager tes cours aux autres (surtout les plus simples),
                    mais surtout que cela pourra engendrer des frais pour ton
                    club dans le futur. (on est en beta-test donc pas
                    d'inquiétude pour l'instant)
                </p>
                <p>
                    Une leçon est constituée de texte où je te conseillerai
                    d'écrire les éléments suivants :
                </p>
                <ul>
                    <li>Le contenu de ta leçon</li>
                    <li>
                        Les difficultés rencontrées à l'expliquer et à la faire
                        comprendre
                    </li>
                    <li>
                        Les questions que les élèves t'ont posées et comment y
                        répondre
                    </li>
                </ul>
                <p>
                    Tout cela dans le but qu'elle puisse être réutilisée le plus
                    facilement possible (par un autre club, toi l'année
                    prochaine, etc...)
                </p>
                <p>
                    Tu pourras mettre des exercices sur ta leçon : des simples
                    et des explicatifs. Les simples sont les exercices à envoyer
                    aux élèves. Ils doivent comporter le moins de commentaire
                    possible (voir pas du tout) car ils servent à tester les
                    élèves. Les explicatifs sont des cours à part entière. Ne
                    les envoies pas aux élèves pour l'instant, mais n'hésites
                    pas à en créer pour partager des séquences avec les autres
                    professeurs.
                </p>
                <p>
                    Les exercices suivent le format suivant :
                </p>
                <ul>
                    <li>
                        une situtation initiale : sur CGoban par exemple, on
                        modifie le goban vide pour la créer
                    </li>
                    <li>
                        Tu peux envoyer la taille de goban que tu souhaites, en
                        plus Gollege te permet de découper le problème autour
                        des pierres, et donc de zoomer si tu le souhaites.
                    </li>
                    <li>
                        le reste sera expliqué par selon l'exercice via une
                        infobulle qui vous décrira l'exercice choisi
                    </li>
                </ul>
                <p>Rien de plus ! Merci de m'avoir lu jusque là !</p>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import Axios from '@/auth/axiosAuth';
import UIkit from 'uikit';
import FiltreParNiveau from './FiltreParNiveau.vue';
import Multiselect from 'vue-multiselect';
import ElementListeLecon from './ElementListeLecon.vue';
import AffichageClassesEleves from '@/components/AffichageClassesEleves.vue';
import ListeTypeExercice from '@/components/presentation/ListeTypeExercice.vue';
import ExperienceUtilisateur from '@/classes/ExperienceUtilisateur';

@Component({
    components: {
        FiltreParNiveau,
        Multiselect,
        ElementListeLecon,
        AffichageClassesEleves,
        ListeTypeExercice
    }
})
export default class ListeLecons extends Vue {
    private lecons: any[] = [];
    private recherche = '';
    private leconAAfficher: any[] = [];
    private niveauMin = -50;
    private niveauMax = 7;
    private tagsUtilise = [];
    private tagsDisponibles = [];
    private classes: any[] = [];
    private elevesSansLecon = [];
    private elevesPossedantLecon = [];
    private typeProbleme = '';

    beforeRouteEnter(to, from, next) {
        next(vm => {
            Axios.get('lecon/club/' + vm.$auth.user.idClub, response => {
                vm.lecons = response.data;
                vm.leconAAfficher = vm.lecons;
                vm.lecons
                    .flatMap(lecon =>
                        lecon.exercicesCours.concat(lecon.exercicesEntrainement)
                    )
                    .flatMap(probleme => probleme.tagsProbleme)
                    .map(tag => tag.libelle)
                    .filter(
                        (value, index, self) => self.indexOf(value) === index
                    )
                    .forEach(tag => {
                        vm.tagsDisponibles.push({
                            name: tag,
                            code: tag
                        });
                    });
            });
            Axios.get('professeur/eleves/' + vm.$auth.user.id, response => {
                vm.classes = response.data;
            });
        });
    }

    mounted() {
        const experience: ExperienceUtilisateur = this.$auth.user.getExperience();
        if (!experience.getLecon()) {
            UIkit.modal('#modal-description').show();
            Axios.post(
                'utilisateur/experience/lecon/' + this.$auth.user.id,
                () => (experience.setLecon(true))
            );
        }
    }

    public setValeursNiveau(min: number, max: number) {
        this.niveauMin = min;
        this.niveauMax = max;
        this.filtrerLecons();
    }

    public mettreAJourRecherche(recherche: string) {
        this.recherche = recherche;
        this.filtrerLecons();
    }

    public filtrerLecons() {
        this.leconAAfficher = this.lecons.filter(
            lecon =>
                lecon.titre
                    .toLowerCase()
                    .includes(this.recherche.toLowerCase()) &&
                this.isLeconDansNiveauDemande(lecon) &&
                this.isLeconATagsDemandes(lecon) &&
                this.isEleveSansLecon(lecon) &&
                this.isElevePossedantLecon(lecon) &&
                this.isLeconPossedeTypeProbleme(lecon)
        );
    }

    private isLeconDansNiveauDemande(lecon: any): boolean {
        const minLecon = this.getValeurNiveau(lecon.niveauPlusBas);
        const maxLecon = this.getValeurNiveau(lecon.niveauPlusHaut);
        return minLecon >= this.niveauMin && maxLecon <= this.niveauMax;
    }

    private getValeurNiveau(niveau: string): number {
        if (niveau) {
            const nivValeur = parseInt(niveau.substring(0, niveau.length - 1));
            const kyuDan = niveau.substring(niveau.length - 1);
            if ('k' === kyuDan) {
                return nivValeur * -1;
            } else {
                return nivValeur - 1;
            }
        } else {
            return -50; //pas de probleme dans la lecon - apparait toujours
        }
    }

    private isLeconATagsDemandes(lecon: any): boolean {
        const tagLecon: string[] = lecon.tagsProbleme ? lecon.tagsProbleme.map(tags => tags.libelle) : [];
        const tagNonContenu = this.tagsUtilise.filter(
            tag => !tagLecon.includes(tag.name)
        );
        return tagNonContenu.length === 0;
    }

    private isEleveSansLecon(lecon: any): boolean {
        return (
            lecon.eleves.length === 0 ||
            !lecon.eleves
                .map(eleve => eleve.id)
                .some(id => this.elevesSansLecon.includes(id))
        );
    }

    private isElevePossedantLecon(lecon: any): boolean {
        return (
            this.elevesPossedantLecon.length === 0 ||
            lecon.eleves
                .map(eleve => eleve.id)
                .some(id => this.elevesPossedantLecon.includes(id))
        );
    }

    private isLeconPossedeTypeProbleme(lecon: any): boolean {
        return (
            this.typeProbleme === '' ||
            lecon.exercicesEntrainement
                .map(exercice => exercice.typeProbleme)
                .some(type => type === this.typeProbleme)
        );
    }

    private enregistrerElevesSansLecon(elevesChecked: any[]) {
        this.elevesSansLecon = elevesChecked;
        this.filtrerLecons();
    }

    private enregistrerElevesPossedantLecon(elevesChecked: any[]) {
        this.elevesPossedantLecon = elevesChecked;
        this.filtrerLecons();
    }

    private changerTypeExercice(typeProbleme: string) {
        this.typeProbleme = typeProbleme;
        this.filtrerLecons();
    }
}
</script>

<style scoped>
.type {
    color: #333;
}
</style>
